<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2015 osCommerce

  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  if (!function_exists('tep_address_label')) {
    function tep_address_label($customers_id, $address_id = 1, $html = false, $boln = '', $eoln = "\n") {
      if (is_array($address_id) && !empty($address_id)) {
        return tep_address_format($address_id['address_format_id'], $address_id, $html, $boln, $eoln);
      }

      $address_query = tep_db_query("select entry_firstname as firstname, entry_lastname as lastname, entry_company as company, entry_street_address as street_address, entry_suburb as suburb, entry_city as city, entry_postcode as postcode, entry_state as state, entry_zone_id as zone_id, entry_country_id as country_id from " . TABLE_ADDRESS_BOOK . " where customers_id = '" . (int)$customers_id . "' and address_book_id = '" . (int)$address_id . "'");
      $address = tep_db_fetch_array($address_query);

      $format_id = tep_get_address_format_id($address['country_id']);

      return tep_address_format($format_id, $address, $html, $boln, $eoln);
    }
  }

  if (!function_exists('tep_get_address_format_id')) {
    function tep_get_address_format_id($country_id) {
      $address_format_query = tep_db_query("select address_format_id as format_id from " . TABLE_COUNTRIES . " where countries_id = '" . (int)$country_id . "'");
      if (tep_db_num_rows($address_format_query)) {
        $address_format = tep_db_fetch_array($address_format_query);
        return $address_format['format_id'];
      } else {
        return '1';
      }
    }
  }

  class payment_demo {
    var $title, $email_footer;

    function payment_demo() {
      $this->title = TITLE_PAYMENT_DEMO;
      $this->email_footer = TEXT_EMAIL_FOOTER_DEMO;
    }
  }

  require(DIR_WS_CLASSES . 'currencies.php');
  $currencies = new currencies();

  require(DIR_FS_CATALOG . DIR_WS_CLASSES . 'osc_template.php');
  $oscTemplate = new oscTemplate();

  $page = (isset($_GET['page']) ? $_GET['page'] : '');
  $mode = (isset($_GET['html']) ? 'html' : 'text');

  $last_order_query = tep_db_query("select max(orders_id) as last_orders_id from orders");
  $order_id = tep_db_fetch_array($last_order_query);

  $oID = $order_id['last_orders_id'];

  $template = '';

  switch ($page) {
    case 'create_account' :
      require(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $language . '/create_account.php');

      $last_account_query = tep_db_query("select max(customers_id), customers_firstname, customers_lastname from " . TABLE_CUSTOMERS . "");

      $last_account = tep_db_fetch_array($last_account_query);

      $email_text = sprintf(EMAIL_GREET_NONE, $last_account['customers_firstname']);

      ob_start();
      include(DIR_FS_CATALOG . DIR_WS_MODULES . 'pages/templates/email_create_account_' . $mode . '.php');
      $template .= ob_get_clean();

    break;
    case 'paypal_standard' :
      $order_id = $oID;
    case 'checkout_process' :
      $$payment = new payment_demo;
      if (tep_not_null($oID)) {
        require(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $language . '/checkout_process.php');

        include(DIR_FS_CATALOG . DIR_WS_CLASSES . 'order.php');
        $order = new order($oID);

        $insert_id = $oID;

        $comment_query = tep_db_query("select comments from orders_status_history where orders_id = '" . $oID . "' limit 1");
        $comment = tep_db_fetch_array($comment_query);

        $order->info['comments'] = $comment['comments'];

        require(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $language . '/modules/payment/cod.php');
        require(DIR_FS_CATALOG . DIR_WS_MODULES . 'payment/cod.php');

        $order_totals = $order->totals;

        $customer_id = $order->customer['id'];

        $customer_info_query = tep_db_query("select c.customers_firstname, c.customers_default_address_id, ab.entry_country_id, ab.entry_zone_id from " . TABLE_CUSTOMERS . " c left join " . TABLE_ADDRESS_BOOK . " ab on (c.customers_id = ab.customers_id and c.customers_default_address_id = ab.address_book_id) where c.customers_id = '" . (int)$customer_id . "'");
        $customer_info = tep_db_fetch_array($customer_info_query);

        $sendto = $customer_info['customers_default_address_id'];
        $billto = $customer_info['customers_default_address_id'];

        $products_ordered = '';
        for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
          $products_ordered_attributes = '';
          $products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ')';

          if (isset($order->products[$i]['attributes']) && (sizeof($order->products[$i]['attributes']) > 0)) {
            for ($j = 0, $k = sizeof($order->products[$i]['attributes']); $j < $k; $j++) {
              $products_ordered_attributes .= "\n\t" . $order->products[$i]['attributes'][$j]['option'] . ': ' . $order->products[$i]['attributes'][$j]['value'];
            }
          }

          $products_ordered .= ' = ' . $currencies->format(tep_add_tax($order->products[$i]['final_price'], $order->products[$i]['tax'], true) * $order->products[$i]['qty'], true, $order->info['currency'], $order->info['currency_value']) . $products_ordered_attributes . "\n";
        }

        ob_start();
        include(DIR_FS_CATALOG . DIR_WS_MODULES . 'pages/templates/email_' . $page . '_' . $mode . '.php');
        $template .= ob_get_clean();
      } else {
        $template = ERROR_NO_ORDER;
        $mode = 'text';
      }
    break;
    case 'order' :
      if (tep_not_null($oID)) {
        $orders_statuses = array();
        $orders_status_array = array();
        $orders_status_query = tep_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . (int)$languages_id . "'");
        while ($orders_status = tep_db_fetch_array($orders_status_query)) {
          $orders_statuses[] = array('id' => $orders_status['orders_status_id'],
                                     'text' => $orders_status['orders_status_name']);
          $orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
        }

        include(DIR_WS_LANGUAGES . $language . '/orders.php');

        $orders_history_query = tep_db_query("select max(orders_status_id) as max_orders_status_id, date_added, customer_notified, comments from " . TABLE_ORDERS_STATUS_HISTORY . " where orders_id = '" . tep_db_input($oID) . "'");

        $orders_history = tep_db_fetch_array($orders_history_query);
        $status = $orders_history['max_orders_status_id'];
        $comments = $orders_history['comments'];

        $_POST['notify_comments'] = ($orders_history['customer_notified'] == '1' ? 'on' : '');

        // $order_updated = false;
        $check_status_query = tep_db_query("select customers_name, customers_email_address, orders_status, date_purchased from " . TABLE_ORDERS . " where orders_id = '" . (int)$oID . "'");
        $check_status = tep_db_fetch_array($check_status_query);
        $customer_notified = '1';

        $notify_comments = sprintf(EMAIL_TEXT_COMMENTS_UPDATE, $comments) . "\n\n";

        ob_start();
        include(DIR_WS_MODULES . 'pages/templates/email_order_' . $mode . '.php');
        $template .= ob_get_clean();
      } else {
        $template = ERROR_NO_ORDER;
        $mode = 'text';
      }
    break;
    case 'tell_a_friend' :
      require(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $language . '/tell_a_friend.php');
      $_GET['products_id'] = '100';
      $to_name = 'Bill';
      $from_name = 'Andrea';
      $message = 'Bill,' . "\n" . 'this is very cool product!';
      $product_info['products_name'] = 'Matrox G200 MMS';

      $email_body = sprintf(TEXT_EMAIL_INTRO, $to_name, $from_name, $product_info['products_name'], STORE_NAME) . "\n\n";

      if (tep_not_null($message)) {
        $email_body .= $message . "\n\n";
      }

      ob_start();
      include(DIR_FS_CATALOG . DIR_WS_MODULES . 'pages/templates/email_tell_a_friend_' . $mode . '.php');
      $template .= ob_get_clean();
    break;
    case 'password_forgotten':
      require(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $language . '/password_forgotten.php');

      $email_address = 'who@is.com';
      $reset_key = 'jjhlflkjélasiéflakjsdéafasédjfhaélsdhrrt';

      $reset_key_url = tep_catalog_href_link('password_reset.php', 'account=' . urlencode($email_address) . '&key=' . $reset_key, 'SSL', false);

      $email_text = sprintf(EMAIL_PASSWORD_RESET_BODY, $reset_key_url);

      ob_start();
      include(DIR_FS_CATALOG . DIR_WS_MODULES . 'pages/templates/email_password_forgotten_' . $mode . '.php');
      $template .= ob_get_clean();
    break;
    default:
      $template = ERROR_TEXT_NO_PAGE;
      $mode = 'text';
  }


  if ($mode == 'text') {
    $template = strip_tags($template);
    header("Content-Type: text/plain");
    echo "\xEF\xBB\xBF";
  }

  echo $template;

  require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
